<?php
/**
 * Created by JetBrains PhpStorm.
 * User: alessandrobartel
 * Date: 02/07/12
 * Time: 11:13
 * To change this template use File | Settings | File Templates.
 */

class Homolognet {

    const EMPREGADOR = '1';
    const EMPREGADO = '2';
    const CONTRATO = '3';
    const DECIMO_TERCEIRO = '4';
    const FINANCEIRO = '6';
    const DESCONTO = '7';
    const CODIGO = '8';

    const IMPOSTORENDA = '2';
    const SALARIOFAMILIA = '1';

    const CONTRATO_PARCIAL = '25';
    const CONTRATO_PARCIAL_SIM = '1';
    const CONTRATO_PARCIAL_NAO = '2';

    const TIPO_FORMACAO_FIXO = '1';
    const TIPO_FORMACAO_VARIAVEL = '2';
    const TIPO_FORMACAO_FIXOVARIAVEL = '3';

    private $_nrOrg;
    private $_nrOrgPadrao;
    private $_mesCompetencia;

    private $_dtAux;
    private $_dtAux2;
    private $_dtRescisao;

    private $_calendario;

    private $_estruturacao;
    private $_pessoa;
    private $_vinculo;
    private $_ferias;
    private $_tpMovTransfM;
    private $_itemCalculo;
    private $_evento;
    private $_assocEvento;

    private $_listaCalculoFolha;
    private $_listaEventosGrupoIncidencia;
    private $_itemGrupo;
    private $_tpDemissao;
    private $_vinculoEmpreg;
    private $_sitFuncional;
    private $_cnabMagnet;

    private $_homologMagnet;

    //empregador
    private $_empregadorHnet;

    //empregado
    private $_empregadoHnet;
    private $_enderecoParc;
    private $_municipio;
    private $_bairro;

    //contrato
    private $_contratoHnet;
    private $_cbo;
    private $_ocupacao;
    private $_escalaTrabalho;
    private $_dependentes;
    private $_dadoPensaoJuridica = array();

    //ferias
    private $_feriasHnet;
    private $_altSitFunc;

    //desconto
    private $_Nrfaltas = 0;

    private $_decimoTerceiroHnet;
    private $_movimentacaoHnet;
    private $_financeiroHnet;
    private $_descontoHnet;
    private $_codigoHnet;
    private $_rubrica;
    private $_listaRubricaInterna;
    private $_listaRubricaExterna;
    private $_MotivoAfastamento;

    private $_nrInscricao;
    private $_nrTpInscricao;
    private $_nrInscricaoTom;
    private $_nrTpInscricaoTom;


    public function __construct(
        $nrOrg, $nrOrgPadrao, $mesCompetencia, $formulario, FpaHomologmagnetEntity $homologMagnet, FpaGrpitemEntity $itensGrupo, $listaCalculoFolha,
        $listaEventosGrupoIncidencia
    ){

        $this->_nrOrg = $nrOrg;
        $this->_nrOrgPadrao = $nrOrgPadrao;
        $this->_mesCompetencia = $mesCompetencia;

        $this->_dtAux = new TkDateTime();
        $this->_dtAux2 = new TkDateTime();
        $this->_pessoa = new GpepessoaEntity(null, $this->_nrOrg, $this->_mesCompetencia);
        $this->_calendario = new CalendarioLogic($this->_nrOrg, $this->_nrOrgPadrao);

        $this->_listaCalculoFolha = $listaCalculoFolha;
        $this->_listaEventosGrupoIncidencia = $listaEventosGrupoIncidencia;
        $this->_itemGrupo = $itensGrupo;

        $this->_cnabMagnet = new FpaCnabmagnetEntity();

        $this->_homologMagnet = $homologMagnet;

        //empregador
        $this->_empregadorHnet = new RegistroEmpregadorHomolognet();

        //empregado
        $this->_empregadoHnet = new RegistroEmpregadoHomolognet();
        $this->_enderecoParc = new EnderecoparcEntity();
        $this->_municipio = new MunicipioEntity();
        $this->_bairro = new BairroEntity();

        //contrato
        $this->_contratoHnet = new RegistroContratoHomolognet();
        $this->_cbo = new GpeCboEntity();
        $this->_ocupacao = new GpeOcupacaomEntity(null, $this->_nrOrg, $this->_mesCompetencia);
        $this->_escalaTrabalho = new GpeescalatrabmEntity();
        $this->_dependentes = new FpadepvinculoEntity(null, $this->_nrOrg, $this->_nrOrgPadrao );

        //ferias
        $this->_altSitFunc = new GpealtesitufuncEntity();

        $this->_tpDemissao = new FpaTpdemissaoEntity(null, $this->_nrOrgPadrao, $this->_nrOrg);
        $this->_feriasHnet = new RegistroFeriasHomolognet();
        $this->_decimoTerceiroHnet = new Registro13SalarioHomolognet();
        $this->_movimentacaoHnet = new RegistroMovimentacaoHomolognet();
        $this->_financeiroHnet = new RegistroFinanceiroHomolognet();
        $this->_descontoHnet = new RegistroDescontoHomolognet();
        $this->_codigoHnet = new RegistroCodigoHomolognet();
        $this->_rubrica = new FpaHomologrubricaEntity();

        $this->_vinculoEmpreg = new GpevinculoempregEntity();
        $this->_sitFuncional = new GpesitufuncmEntity();
        $this->_MotivoAfastamento = new GpemotivoafastaEntity();

        $this->_estruturacao = new Estruturacao($this->_nrOrg, $this->_nrOrgPadrao, $this->_mesCompetencia);
        $this->_vinculo = new GpevinculomEntity();
        $this->_ferias = new FpaFeriasEntity(null, $this->_nrOrg, $this->_nrOrgPadrao, $this->_mesCompetencia);
        $this->_tpMovTransfM = new GpetpmovtransfmEntity(null, $this->_nrOrgPadrao, $this->_nrOrg, $this->_mesCompetencia);
        $this->_itemCalculo = new FpaitecalcfolhaEntity();
        $this->_evento = new FpaeventomEntity(null, $this->_nrOrg, $this->_nrOrgPadrao, $this->_mesCompetencia);
        $this->_assocEvento = new FpaAssoceventoEntity(null, $this->_nrOrg);

        $this->_inicializaVariaveis($formulario);

    }


    private function _inicializaVariaveis($formulario){

        $this->_estruturacao->carregaHierarquias($formulario->getNrhierarqorg());
        $this->_estruturacao->carregaHierarquiasTomador($formulario->getNrhierartomador());
        $this->_estruturacao->carregaTipoHierarquia($formulario->getNrhierarqorg());
        $this->_estruturacao->carregaTipoHierarquiaTomador($formulario->getNrhierartomador());

    }

    public function geraHomolognet($vinculo, $tpInscHierarq, $tpInscHierarqTom){
//    public function geraHomolognet($vinculo, $nrHierarquiaOrg, $nrHierarquiaTomador, $tpInscricaoHierarquia, $tpInscricaoHierarquiaTom){

//        carrega os itens de calculo do ultimos 85 meses
//        $this->_carregaItensCalculo($vinculo->getNrvinculom());

        $this->_vinculo = $vinculo;
        $this->_dtRescisao = $this->_vinculo->getDtrescisaovinc();

        // retorna as movimentacoes do vinculo
        $movimentacoes = $this->_estruturacao->getMovimentacoesVinculo($this->_vinculo->getNrvinculom());

        // define estrutura sindical.
        $estruturaSindical = $this->_estruturacao->retornaEstrutura($this->_vinculo->historico->getNrestrutsind());

        // inicializa estrutura responsavel
        $estruturaResp = '';

        // loop nas movimentacoes
        foreach ($movimentacoes as $movimentacao){

            // Pegar estrutura.
            $estruturaResp = $this->_estruturacao->getEstruturaSuperior($movimentacao);
            if ($estruturaResp !== null) {
                if ($tpInscHierarq === RegistroHomolognet::CNPJ) {
                    $this->_nrInscricao = $estruturaResp->historico->getCdcnpjestrut();
                    $this->_nrTpInscricao = RegistroHomolognet::CNPJ;
                } elseif ($tpInscHierarq === RegistroHomolognet::CEI) {
                    $this->_nrInscricao = $estruturaResp->historico->getCdceiestrut();
                    $this->_nrTpInscricao = RegistroHomolognet::CEI;
                }

                // Dados de inscricao da Estrutura Tomador
                if ($tpInscHierarqTom !== null) {
                    $estruturaTomador = $this->_estruturacao->getEstruturaSuperiorTomador($movimentacao);
                    if ($tpInscHierarq === RegistroHomolognet::CNPJ) {
                        $this->_nrInscricaoTom = $estruturaTomador->historico->getCdcnpjestrut();
                        $this->_nrTpInscricaoTom = RegistroHomolognet::CNPJ;
                    } elseif ($tpInscHierarq === RegistroHomolognet::CEI) {
                        $this->_nrInscricaoTom = $estruturaTomador->historico->getCdceiestrut();
                        $this->_nrTpInscricaoTom = RegistroHomolognet::CEI;
                    }
                } else {
//                se tomador não estiver definido, recebe zero
                    $this->_nrInscricaoTom = 0;
                    $this->_nrTpInscricaoTom = 0;
                }

                //@todo - Verificar a possibilidade de preparar o Empregador fora do loop. Pegar a movimentacao mais recente.
                // Preparar empregador
                $this->_preparaEmpregador($movimentacao, $estruturaResp, $tpInscHierarq, $tpInscHierarqTom);

                // Loop nas alteracoes salariais
                $this->_preparaVerbasRescisorias(); // ingloba preparaFinanceiro e preparaDescontos

                // Prepara Financeiro
                $this->_preparaFinanceiro($estruturaResp);

            }
        }

        // Prepara o contrato
        $this->_preparaContrato($estruturaSindical);

        // Prepara o empregado
        $this->_preparaEmpregado();

        // Prepara Ferias
        $this->_preparaFerias();

        // Prepara Decimo Terceiro
        $this->_prepara13Salario();

        // Prepara movimentacoes
        $this->_preparaMovimentacao($movimentacoes);

        // Prepara descontos
        $this->_preparaDescontos();


//        // Carrega os itens de calculo do ultimos 85 meses
//        // $this->_carregaItensCalculo($vinculo->getNrvinculom());
//
//        $this->_vinculo = $vinculo;
//        $this->_dtRescisao = $this->_vinculo->getDtrescisaovinc();
//
//
//        //define estrutura sindical.
//        $estruturaSindical = $this->_estruturacao->retornaEstrutura($this->_vinculo->historico->getNrestrutsind());
//
//        //define estrutura responsável através da hierarquia selecionada.
//        $estruturaResp = $this->_estruturacao->getEstruturas($this->_vinculo->getNrvinculom(),$nrHierarquiaOrg);
//
//        if ($estruturaResp) {
//
//            //número de inscrição recebe o cnpj da estrutura responsável
//            if ($tpInscricaoHierarquia === RegistroHomolognet::CNPJ) {
//                $this->_nrInscricao = $estruturaResp->historico->getCdcnpjestrut();
//                $this->_nrTpInscricao = RegistroHomolognet::CNPJ;
//            } elseif ($tpInscricaoHierarquia === RegistroHomolognet::CEI) {
//                $this->_nrInscricao = $estruturaResp->historico->getCdceiestrut();
//                $this->_nrTpInscricao = RegistroHomolognet::CEI;
//            }
//
//            //verifica se hierarquia do tomador está definido no formulário
//            if ($nrHierarquiaTomador) {
//
//                    //define estrutura tomador.
//                    $estruturaTomador = $this->_estruturacao->getEstruturas($this->_vinculo->getNrvinculom(),$nrHierarquiaTomador);
//
//                    if($estruturaTomador){
//
//                        if ($tpInscricaoHierarquiaTom === RegistroHomolognet::CNPJ) {
//                            $this->_nrInscricaoTom = $estruturaTomador->historico->getCdcnpjestrut();
//                            $this->_nrTpInscricaoTom = RegistroHomolognet::CNPJ;
//                        } elseif ($tpInscricaoHierarquiaTom === RegistroHomolognet::CEI) {
//                            $this->_nrInscricaoTom = $estruturaTomador->historico->getCdceiestrut();
//                            $this->_nrTpInscricaoTom = RegistroHomolognet::CEI;
//                        }
//
//                    }else{
//                        throw new Exception('Tipo de estrutura da movimentação para o tomador não existe ou diferente da selecionada no formulário para o vínculo '. $this->_vinculo->getNrvinculom() .'.');
//                    }
//
//            } else {
//
//                // se tomador não estiver definido, recebe zero
//                $this->_nrInscricaoTom = 0;
//                $this->_nrTpInscricaoTom = 0;
//            }
//
//            //prepara_empregador
//
//        }else{
//            throw new Exception('Tipo de estrutura na movimentação não existe ou diferente da selecionada no formulário para o vínculo '. $this->_vinculo->getNrvinculom() .'.');
//        }
//
//        // Preparar empregador // @todo - verificar se tem que ficar aqui ou na linha 160.
//        $this->_preparaEmpregador($estruturaResp);
//
//        // Prepara o empregado
//        $this->_preparaEmpregado();
//
//        // Prepara o contrato
//        $this->_preparaContrato($estruturaSindical);
//
//        // Prepara Ferias
//        $this->_preparaFerias();
//
//        // Prepara Decimo Terceiro
//        //@todo - NÃO IMPLEMENTADO, VERIFICAR MELHOR A REGRA.
//        $this->_prepara13Salario();
//
//        // Prepara movimentacoes // @todo - verificar a melhor forma de pegar as movimentações.
//        $this->_preparaMovimentacao($this->_vinculo->getNrvinculom());
//
////        // Prepara Financeiro
////        $this->_preparaFinanceiro($estruturaResp);
////
////        // Loop nas alteracoes salariais
////        $this->_preparaVerbasRescisorias(); // engloba preparaFinanceiro e preparaDescontos
//
//        // Prepara descontos
//        $this->_preparaDescontos();
//
//

    }


    private function _preparaEmpregador($movimentacao, $estrutura, $tpInscHierarq, $tpInscHierarqTom){

        // Verifica a existencia do empregador no magnetico
        $poscicao = $this->_homologMagnet->procuraRegistroLista(
            $this->_nrInscricao, $this->_nrInscricaoTom, self::EMPREGADOR
        );

        if ($poscicao === false) {

            // Endereco da estrutura
            $estrutura->endereco = $this->_estruturacao->determinaEnderecoEstrutura($estrutura);

            // CNPJ Entidade Sindical ou CEES (MTE) - @todo Parametro da estrutura ???

            // Insere empregador
            $this->_empregadorHnet->setNrTpInscricao($this->_nrTpInscricao);
            $this->_empregadorHnet->setNrInscricao($this->_nrInscricao);
            $this->_empregadorHnet->setNrTpInscricaoTom($this->_nrTpInscricaoTom);
            $this->_empregadorHnet->setNrInscricaoTom($this->_nrInscricaoTom);
            $this->_empregadorHnet->setEstrutura($estrutura);
            $this->_empregadorHnet->geraRegistroEmpregador();

            // Insere empregador na lista
            $this->_homologMagnet->insereRegistroLista(
                $this->_nrOrg, $this->_mesCompetencia, FpaHomologmagnetEntity::IDATIVO_SIM, self::EMPREGADOR,
                $this->_nrTpInscricao, $this->_nrInscricao, $this->_empregadorHnet->getLinhaRegistro(),
                $this->_nrTpInscricaoTom, $this->_nrInscricaoTom
            );

        }

    }


    private function _preparaEmpregado(){

        //verifica a existencia do empregado no magnetico.
        $poscicao = $this->_homologMagnet->procuraRegistroLista(
            $this->_nrInscricao, $this->_nrInscricaoTom, self::EMPREGADO
        );

        if (!$poscicao) {

            $pessoa = $this->_pessoa->retornaPessoaAtual($this->_vinculo->getNrpessoa());

            //retorna os dados do endereco do empregado.
            $enderecoParc = $this->_enderecoParc->retornaEnderecoParceiroPorTipo(
                $this->_nrOrg, $pessoa->getNrparcnegocio(), Estruturacao::ENDERECO_PRINCIPAL
            );

            if (is_object($enderecoParc) === true) {

                //divide o endereco do empregado.
                $enderecoParc->separaDsEndereco();

                //retorna o município
                $municipio = $this->_municipio->retornaMunicipio(
                    $enderecoParc->getCdpais(), $enderecoParc->getSgestado(), $enderecoParc->getCdmunicipio()
                );

                if (is_object($municipio) === true) {
                    $pessoa->municipio = $municipio->getNmmunicipio();
                } else {
                    $pessoa->municipio = null;
                }

                $pessoa->endereco = $enderecoParc->getEndereco();
                $pessoa->numero = $enderecoParc->getNumero();
                $pessoa->complemento = ltrim($enderecoParc->getComplemento());
                $pessoa->bairro = $this->_bairro->defineBairro($enderecoParc);
                $pessoa->uf = $enderecoParc->getSgestado();
                $pessoa->cep = $enderecoParc->getNrcependereco();

            } else {

                $pessoa->endereco = null;
                $pessoa->numero = null;
                $pessoa->complemento = null;
                $pessoa->bairro = null;
                $pessoa->municipio = null;
                $pessoa->uf = null;
                $pessoa->cep = null;

            }

            //seta os parametros.
            $this->_empregadoHnet->setPessoa($pessoa);

            //seta contratos dentro do empregado.
            $this->_empregadoHnet->setContratos($this->_contratoHnet->getLinhaRegistro());

            //gera o registro do empregado.
            $this->_empregadoHnet->geraRegistroEmpregado();

            //insere empregado na lista.
            $this->_homologMagnet->insereRegistroLista(
                $this->_nrOrg, $this->_mesCompetencia, FpaHomologmagnetEntity::IDATIVO_SIM, self::EMPREGADO,
                $this->_nrTpInscricao, $this->_nrInscricao, $this->_empregadoHnet->getLinhaRegistro(),
                $this->_nrTpInscricaoTom, $this->_nrInscricaoTom
            );

        }

    }

    private function _preparaContrato($estruturaSindical){

        //verifica a existencia do contrato no magnetico.
        $poscicao = $this->_homologMagnet->procuraRegistroLista(
            $this->_nrInscricao, $this->_nrInscricaoTom, self::CONTRATO
        );

        if (!$poscicao) {

            //define jornada semanal e tipo de contrato a tempo parcial
            $escalaTrabalho = $this->_escalaTrabalho->retornaEscala($this->_vinculo->historico->getNrescalatrabm(), $this->_nrOrg);
            if (is_object($escalaTrabalho) === true) {
                $this->_vinculo->jornadaSemanal = $escalaTrabalho->historico->getQthrsemesctrabh();
                if ($this->_vinculo->jornadaSemanal <= self::CONTRATO_PARCIAL) {
                    $this->_vinculo->contratoParcial = self::CONTRATO_PARCIAL_SIM;
                }else{
                    $this->_vinculo->contratoParcial = self::CONTRATO_PARCIAL_NAO;
                }
            } else {
                $this->_vinculo->jornadaSemanal = null;
            }

            //define valor pensao alimenticia
            $this->_pensaoJuridica();

            //define tipo de afastamento.
            $nrTipoDemissao = $this->_vinculo->getNrtpdemissao();
            if (empty($nrTipoDemissao) === false) {
                $tpDemissao = $this->_tpDemissao->procuraTipoDemissao($this->_vinculo->getNrtpdemissao());
                $nrCodhomolognet = $tpDemissao->getCodhomolognet();
                if (empty($nrCodhomolognet) === false){
                    $this->_vinculo->codAfastamento = $nrCodhomolognet;
                }else{
                    tk_warning('Afastamento: Código homolognet não parametrizado para o tipo de demissão '. $this->_vinculo->getNrtpdemissao());
                    $this->_vinculo->codAfastamento = null;
                }
            } else {
                tk_warning('Tipo de demissão não parametrizado para o vinculo '. $this->_vinculo->getNrvinculom());
            }

            //define Categoria Trabalhador em situação funcional, se não encontrar pega no vinculoempreg.
            $situacaoFuncional = $this->_sitFuncional->retornaSituacaoFuncional(
                $this->_nrOrgPadrao, $this->_nrOrg, $this->_vinculo->historico->getNrsitufuncm()
            );
            if($situacaoFuncional->historico->getCodcategtrab()){
                $this->_vinculo->codCategTrab = $situacaoFuncional->historico->getCodcategtrab();
            }else{
                $vinculoEmpreg = $this->_vinculoEmpreg->retornaVinculoEmpregaticio($this->_vinculo->getNrvinculoempreg());
                if (is_object($vinculoEmpreg) === true) {
                    $this->_vinculo->codCategTrab = $vinculoEmpreg->getCodcategtrab();
                }else{
                    $this->_vinculo->codCategTrab = null;
                }
            }

            // define quantidade de dependentes do empregado
            $this->_vinculo->numeroDependentesIR = $this->_vinculo->historico->getNrdependir();
            $this->_vinculo->numeroDependentesSF = $this->_vinculo->historico->getNrdependsfam();

//            $this->_dependentes->carregaDependenciasPorVinculo($this->_vinculo->getNrvinculom());
//            $dependentes = $this->_dependentes->getItems();
//            if($dependentes){
//
//                $ir = 0;//imposto de renda
//                $sf = 0;//salario familia
//
//                foreach($dependentes as $dependente){
//
//                    //verifica se o tipo de dependente é imposto de renda.
//                    if($dependente->getNrtipodepende() == self::IMPOSTORENDA){
//                        $ir++;
//                    }
//
//                    //verifica se o tipo de dependente é salário família.
//                    if($dependente->getNrtipodepende() == self::SALARIOFAMILIA){
//                        $sf++;
//                    }
//
//                }
//
//                //verifica se e zero e seta null para não gerar a linha do registro.
//                if($ir === 0) {
//                    $this->_vinculo->numeroDependentesIR = null;
//                }else{
//                    $this->_vinculo->numeroDependentesIR = $ir;
//                }
//
//                //verifica se e zero e seta null para não gerar a linha do registro.
//                if($sf === 0) {
//                    $this->_vinculo->numeroDependentesSF = null;
//                }else{
//                    $this->_vinculo->numeroDependentesSF = $sf;
//                }
//
//            } else {
//                // Se vinculo não possui dependentes seta o IR e SF como 0 (ZERO)
//                tk_warning('Vínculo '. $this->_vinculo->getNrvinculom() .' não possui dependente.');
//                $this->_vinculo->numeroDependentesIR = 0;
//                $this->_vinculo->numeroDependentesSF = 0;
//            }

            // Empregado comprovou emprego durante aviso prévio ?
            $this->_vinculo->idComprovouAviso = tk_get_field_value('IDCOMPROVOUAVISO');
            // Empregador dispensou empregado do aviso prévio ?
            $this->_vinculo->idDispensouAviso =  tk_get_field_value('IDDISPENSOUAVISO');

            //define NrCBO
            $ocupacao = $this->_ocupacao->retornaOcupacao($this->_vinculo->historico->getNrcargo());
            if (is_object($ocupacao) === true){
                $cbo = $this->_cbo->retornaCbo($ocupacao->historico->getNrcbo());
                $this->_vinculo->cbo = $cbo->getCdrais();
            } else {
                $this->_vinculo->cbo = null;
            }

            //define contrato de trabalho
            $tipodemissao = $this->_tpDemissao->procuraTipoDemissao($this->_vinculo->getNrtpdemissao());
            $this->_vinculo->contratoTrabalho = $tipodemissao->getCodtpcontrato();

            //define cnpj da entidade sindical.
            $this->_vinculo->cnpjEntidadeSindical = $estruturaSindical->historico->getCdcnpjestrut();

            //define codigo da entidade sindical. @todo criar campo na tabela estrutura, gerar DAO e Entity
            $this->_vinculo->codEntidadeSindical = $estruturaSindical->historico->getCdsindical();

            //define data base sindical. @todo criar campo na tabela estrutura, gerar DAO e Entity
            $this->_vinculo->dtBaseSindical = $estruturaSindical->historico->getDtbasesindical();

            //gera o registro do contrato.
            $this->_contratoHnet->geraRegistroContrato($this->_vinculo, $this->_dadoPensaoJuridica);

            //insere contrato na lista.
            $this->_homologMagnet->insereRegistroLista(
                $this->_nrOrg, $this->_mesCompetencia, FpaHomologmagnetEntity::IDATIVO_SIM, self::CONTRATO,
                $this->_nrTpInscricao, $this->_nrInscricao, $this->_contratoHnet->getLinhaRegistro(),
                $this->_nrTpInscricaoTom, $this->_nrInscricaoTom
            );

        }

    }

    private function _preparaFerias(){

        // Retorna todas as ferias do vinculo -- $this->_vinculo->getNrvinculom()
        $this->_ferias->retornaFerias($this->_nrOrg, $this->_vinculo->getNrvinculom());

        if ($this->_ferias->countItems() > 0){

            $registros = $this->_ferias->getItems();
            $this->_preparaDataAux(85);

            // loop nas ferias
            foreach($registros as $registro){

                // Verificar se inicio de periodo esta entre os ultimos 85 meses
                if ($this->_dtAux->isEarlier($registro->getDtiniaquisicao()) === true){

                    //define tipo de afastamento do vinculo
                    $registro->situacaofuncional = $this->_vinculo->historico->getNrsitufuncm();

//                    $altSitFunc = $this->_altSitFunc->retornaAlteSituFuncporVinculo($this->_vinculo->getNrvinculom(), $this->_nrOrg);
//                    foreach ($altSitFunc as $item) {
//                        tk_warning($item->getNraltesitufunc());
//                        tk_warning($item->getNrsitufuncm());
//                    }

                    // gera registro de ferias
                    $this->_feriasHnet->setFerias($registro);
                    $this->_feriasHnet->geraRegistroFerias();
                }

            }
        }
    }

    private function _prepara13Salario(){

        // Posiciona a data auxiliar a 72 meses anteriores ao mes da rescisao
        $this->_preparaDataAux(72);
        $anoProcessado = array();
        $faltasInjustificadas = array();
        $decimosTerceiros = array();

        $dominio = Registro13SalarioHomolognet::NAO;

        $i = 0;
        foreach ($this->_listaCalculoFolha as $nrCalculo => $calculo){

            $dtOcorrencia = $calculo->getDtocorrencia();

            // loop nos ultimos 72 meses e verificar a existencia de faltas e eventos de 13 e adiantamento 13.
            if (($this->_dtAux->isEarlier($dtOcorrencia, TkDateTime::FORMAT_DATE) === true)
                || ($this->_dtAux->equals($dtOcorrencia, TkDateTime::FORMAT_DATE) === true)
            ){

                // Calculo de faltas injustificadas
                $this->_itemCalculo->retornaItensPorVinculo($this->_nrOrg, $this->_vinculo->getNrvinculom(), $nrCalculo);
                $itens = $this->_itemCalculo->getItems();

                $referencia = $this->_itemGrupo->calculaReferenciaItemGrupoIncidencia(
                    $dtOcorrencia, $this->_itemCalculo, $this->_evento, RegistroHomolognet::FALTAS_INJUSTIFICADAS
                );

                // alimenta vetor de faltas injustificadas
                $faltasHoras = $this->_decimoTerceiroHnet->faltasHoras;
                $faltasDias = 0;
                foreach ($itens as $item) {
                    if ($item->getNreventom() === RegistroHomolognet::EVENTO_FALTAS_INJUSTIFICADAS_DIAS
                        || $item->getNreventom() === RegistroHomolognet::EVENTO_FALTAS_INJUSTIFICADAS_HORAS) {

                        $valorReferencia = $item->getVrreffolha();

                        if (empty($valorReferencia) === false) {
                            foreach ($faltasHoras as $key_dia => $horas) {
                                if ($valorReferencia == $horas) {
                                    $faltasDias = $key_dia;
                                }
                            }
                            if (array_search($valorReferencia, $faltasHoras) == false) {
                                $faltasDias = $valorReferencia;
                            }
                        }

                        $faltas[$i]["dtOcorrencia"] = $item->getDtocorrencia();
                        $faltas[$i]["referencia"] = $faltasDias;
//                        $faltas[$i]["referencia"] = $item->getVrreffolha();

                        $this->_Nrfaltas += $faltasDias;
//                        $this->_Nrfaltas += $item->getVrreffolha();

                        $this->_dtAux2->set($item->getDtocorrencia());

                        $i++;
                    }
                }

//                $faltas[$i]["dtOcorrencia"] = $dtOcorrencia;
//                $faltas[$i]["referencia"] = $referencia;
                $faltasInjustificadas = $faltas;

                // Calculo decimo terceiro
//                $this->_dtAux2->set($dtOcorrencia);
                $anoOcorrencia = $this->_dtAux2->toString(TkDateTime::YEAR);

                //ano da rescisao.
                $rescisao = new TkDateTime($this->_dtRescisao);
                $anoRescisao = $rescisao->toString(TkDateTime::YEAR);

                if (($this->_dtAux2->isEarlier($anoRescisao, TkDateTime::YEAR)
                    || $this->_dtAux2->equals($anoRescisao, TkDateTime::YEAR)) && (($anoRescisao - $anoOcorrencia) <= 5)) {

                    $valorAdiantamento = $this->_itemGrupo->calculaValorItemGrupoIncidencia(
                        $dtOcorrencia, $this->_itemCalculo, $this->_evento, RegistroHomolognet::ADIANTAMENTO_13SALARIO
                    );

                    $valorComplemento = $this->_itemGrupo->calculaValorItemGrupoIncidencia(
                        $dtOcorrencia, $this->_itemCalculo, $this->_evento, RegistroHomolognet::COMPLEMENTO_13SALARIO
                    );

                    if ($valorAdiantamento > 0) {
                        $dominio = Registro13SalarioHomolognet::PARCIAL;
                    }

                    if ($valorComplemento > 0) {
                        $dominio = Registro13SalarioHomolognet::SIM;
                    }

                    if (array_key_exists($anoOcorrencia, $anoProcessado) === false){
                        $dominio = Registro13SalarioHomolognet::NAO;
                    }
                    // Armaneza no ano se foi pago o
                    $anoProcessado[$anoOcorrencia] = $dominio;
                }

            }
        }

        $i = 0;
        foreach ($anoProcessado as $ano => $dominio){

            $this->_dtAux2->setYear($ano);
            $dtOcorrencia = $this->_dtAux2->toString(TkDateTime::FORMAT_DATE);

            // alimente vetor de decimos terceiros
            $decimos[$i]["dtOcorrencia"] = $dtOcorrencia;
            $decimos[$i]["dominio"] = $dominio;
            $decimosTerceiros = $decimos;

            $i++;
        }

        $this->_decimoTerceiroHnet->geraRegistro13Salario($faltasInjustificadas, $decimosTerceiros);

        //insere decimo terceiro na lista.
        $this->_homologMagnet->insereRegistroLista(
            $this->_nrOrg, $this->_mesCompetencia, FpaHomologmagnetEntity::IDATIVO_SIM, self::DECIMO_TERCEIRO,
            $this->_nrTpInscricao, $this->_nrInscricao, $this->_decimoTerceiroHnet->getDecimoTerceiro(),
            $this->_nrTpInscricaoTom, $this->_nrInscricaoTom
        );

    }

    private function _preparaMovimentacao($movimentacoes){
        //prepara a movimentação, contando os últimos 84 meses.
        $this->_preparaDataAux(84);

        //loop nas movimentacoes
//        foreach ($movimentacoes as $movimentacao){
//
//            $nrMotivoAfasta = $movimentacao->getNrmotivoafasta();
//
//            // So gerar movimentacoes referentes aos ultimos 84 meses
//            if (($this->_dtAux->isEarlier($movimentacao->getDtinimoviment()) === true) && (empty($nrMotivoAfasta)=== false)) {
//
//                $afastamento = $this->_MotivoAfastamento->carregaMotivoAfastamento($nrOrg = 0, $nrMotivoAfasta);
//                $Cdhomolognet = $afastamento->getCdhomolognet();
//                if (empty($Cdhomolognet) !== true) {
//                    $this->_movimentacaoHnet->setMotivoMovimentacao($afastamento->getCdhomolognet());
//                    $this->_movimentacaoHnet->setDtMovimentacao($movimentacao->getDtinimoviment());
//                    $this->_movimentacaoHnet->geraRegistroMovimentacao();
//                }else{
//                    tk_warning('Não gerou movimentacão pois o motivo de afastamento parametrizado para a movimentacao '.$movimentacao->getNrmovimentacao().' não possui codigo homolognet parametrizado.');
//                }
//
//            }else{
//                tk_warning('Movimentação '.$movimentacao->getNrmovimentacao().' não possui motivo de afastamento parametrizado.');
////                throw new Exception('Motivo de transferencia nao parametrizado na movimentacao do vinculo '.$nrvinculom);
//            }
//
//        }

        foreach ($movimentacoes as $movimentacao){

            $tpTransf = $movimentacao->getNrtpmovtransfm();

            // So gerar movimentacoes referentes aos ultimos 84 meses
            if (($this->_dtAux->isEarlier($movimentacao->getDtinimoviment()) === true) && (empty($tpTransf)=== false)) {

                $tpMovTransf = $this->_tpMovTransfM->retornaTpMovTransf($movimentacao->getNrtpmovtransfm());

                if (is_object($tpMovTransf) === true) {
                    $codHomolognet = $tpMovTransf->historico->getCodhomolognet();
                }

                if (empty($codHomolognet) === false) {
                    $this->_movimentacaoHnet->setMotivoMovimentacao($codHomolognet);
                    $this->_movimentacaoHnet->setDtMovimentacao($movimentacao->getDtinimoviment());
                    $this->_movimentacaoHnet->geraRegistroMovimentacao();
                }else{
                    tk_warning('Nao gerou movimentacao pois o tipo de transferencia parametrizado para a movimentacao '.$movimentacao->getNrmovimentacao().' nao possui codigo homolognet parametrizado.');
                }

            }else{
                tk_warning('Movimentação '.$movimentacao->getNrmovimentacao().' não possui transferência parametrizado.');
                //throw new Exception('Motivo de transferencia nao parametrizado na movimentacao do vinculo '.$nrvinculom);
            }

        }
    }

    private function _preparaFinanceiro(EstruturamEntity $estrutura){

        // preparar data auxiliar dos 85 ultimos meses
        $this->_preparaDataAux(85);
        $financeiro = null;
        $salario = Array();

        // Faz loop no array de calculo folha
        foreach ($this->_listaCalculoFolha as $nrCalculo => $calculo){

            // Verifica se esta no periodo dos 85 meses
            if (($this->_dtAux->isEarlier($calculo->getDtocorrencia(), TkDateTime::FORMAT_DATE) === true)
                || ($this->_dtAux->equals($calculo->getDtocorrencia(), TkDateTime::FORMAT_DATE) === true)
            ){

                // Calcula o numero de meses entre o mes da competencia e a data de ocorrencia do calculo
                $this->_dtAux2->set($calculo->getDtocorrencia());
                $mesAnterior = $this->_mesCompetencia->months($this->_dtAux2->toString(TkDateTime::FORMAT_DATE));

                // Carrega os itens de calculo para cada calculo de folha
                $this->_itemCalculo->retornaItensPorVinculo($this->_nrOrg, $this->_vinculo->getNrvinculom(), $nrCalculo);
                $itens = $this->_itemCalculo->getItems();

                // Se data da competencia for igual a data de ocorrencia do calculo, busca os itens do calculo
//                $dtCompetencia = new TkDateTime($this->_mesCompetencia);
//                $dtOcorrencia = new TkDateTime($calculo->getDtocorrencia());
//                if ($dtOcorrencia->equals($dtCompetencia)) {
                    foreach($itens as $item){

                        $nreventos = $item->getNreventom();

                        switch($this->_vinculo->historico->getIdtppagamento()){
                            case GpeVinculohEntityBase::IDTPPAGAMENTO_MENSAL_SALARIO_HORA:
                                $salario[$calculo->getDtocorrencia()]['tipoSalario'] = RegistroFinanceiroHomolognet::TIPO_SALARIO_HORA;
                                break;
                            case GpeVinculohEntityBase::IDTPPAGAMENTO_MENSAL:
                                $salario[$calculo->getDtocorrencia()]['tipoSalario'] = RegistroFinanceiroHomolognet::TIPO_SALARIO_MENSAL;
                                break;
                            case GpeVinculohEntityBase::IDTPPAGAMENTO_DIARIO:
                                $salario[$calculo->getDtocorrencia()]['tipoSalario'] = RegistroFinanceiroHomolognet::TIPO_SALARIO_DIARIO;
                                break;
                            default:
                                $salario[$calculo->getDtocorrencia()]['tipoSalario'] = '';
                        }

                        //tratamento para o campo 71 do layout do Homolognet
                        // Mes -1 é o anterior ao mes da rescisao
                        if ($mesAnterior === -1){
                            //                    Caso raro de acontecer - O pagamento nao foi feito e o funcionario foi demitido antes do 5o dia util
                            //                    Só sera informado para pagamento na rescisão caso o salário do mês anterior ainda não tenha sido
                            //                    pago e a data de quitação da rescisão do contrato de trabalho venha a ocorrer até o quinto dia
                            //                    útil do mês seguinte ao de pagamento do salário não quitado.
                            //
                            // Verificar se foi gerado o pagamento para o vinculo (Olhar para o CNAB)
                            $pagamento = $this->_cnabMagnet->retornaRegistroPorVinculoSegmento(
                                $this->_nrOrg, $this->_dtAux2, $this->_vinculo->getNrvinculom(), Registro3ACNABSantander::SEGMENTO_A
                            );

                            if (is_object($pagamento) === false){
                                //se pagamento nao foi feito procurar por evento de liquido
                                if ($nreventos == FpaTipoassoceveEntity::ASSOC_LIQUIDO) {
                                    $financeiro->liquido = Valor::arredonda($item->getVreventofolha(), Valor::TOTAL, -2, 5);
                                }

                            }
                        }
                        //fim do tratamento para o campo 71 do layout do Homolognet

//                        @todo verificar implementacao
                        $eventosVariaveis = Array(''.FpaitecalcfolhaEntity::EVENTO_COMISSAO.'','','');
                        $calculo->tipoFormacao = '';
                        if ($nreventos == FpaitecalcfolhaEntity::EVENTO_COMISSAO) {
                            $salario[$calculo->getDtocorrencia()]['tipoFormacao'] = self::TIPO_FORMACAO_FIXOVARIAVEL;
                        } else {
                            $salario[$calculo->getDtocorrencia()]['tipoFormacao'] = self::TIPO_FORMACAO_FIXOVARIAVEL;
//                            $salario[$calculo->getDtocorrencia()]['tipoFormacao'] = self::TIPO_FORMACAO_FIXO;
                        }

                        $evento = $this->_evento->retornaEvento($item->getNreventom());
                        $codRubrica = $evento->historico->getNrhomologrubrica();
                        $tipoEvento = $evento->getIdtipoevento();
                        $valor = $item->getVreventofolha();
                        $referencia = $item->getVrreffolha();
                        $percentual = $evento->historico->getVrpercentualevento();

                        if (empty($valor) === false || empty($referencia) === false) {

                            if ((empty($codRubrica) === false) && ($tipoEvento === FpaEventomEntity::IDTIPOEVENTO_PROVENTO)){
    //                            tk_warning('Evento:'. $item->getNreventom() .' Cod Rub: '. $codRubrica .' Tipo '. $tipoEvento);
                                $objRubrica = $this->_rubrica->retornaRubrica($this->_nrOrg, $this->_nrOrgPadrao, $codRubrica);

                                $orientacao = $objRubrica->getIdorientacao();

                                if ($orientacao === FpaHomologrubricaEntity::IDORIENTACAO_INTERNA){
                                    // ----------------|
                                    // RUBRICA INTERNA |
                                    // ----------------|
    //                                $rubrica = new stdClass();
                                    $rubrica = Array();
                                    $rubrica['codigo'] = $objRubrica->getCdhomologrubrica();

                                    if ($objRubrica->getIdvalor() === FpaHomologrubricaEntity::IDVALOR_SIM){
                                        $rubrica['valor'] = Valor::arredonda($valor, Valor::TOTAL, -2, 5);
                                        if (empty($rubrica['valor']) === true) {
                                            $rubrica['valor'] = '0.00';
                                        }
                                    }

                                    // Quantidade de Produtos
                                    if ($objRubrica->getIdquantidade() === FpaHomologrubricaEntity::IDQUANTIDADE_SIM){
                                        $rubrica['quantidade'] = $referencia;
                                        if (empty($rubrica['quantidade']) === true) {
                                            $rubrica['quantidade'] = '00';
                                        }
                                    }

                                    // Percentual evento
                                    if ($objRubrica->getIdpercentual() === FpaHomologrubricaEntity::IDPERCENTUAL_SIM){
                                        $rubrica['percentual'] = $percentual;
                                        if (empty($rubrica['percentual']) === true) {
                                            $rubrica['percentual'] = '0.00';
                                        }
                                    }

                                    // Base de calculo - Valor unitario para produto, valor total para os demais
                                    if ($objRubrica->getIdbasecalculo() === FpaHomologrubricaEntity::IDBASECALCULO_SIM){
                                        if (empty($rubrica->quantidade) === false){
                                            // Caso PRODUCAO
                                            $baseCalculo = $valor / $rubrica->quantidade;
                                        } else {
                                            // Caso INSALUBRIDADE, PERICILOSIDADE, TEMPO SERVICO, TRANSFERENCIA
                                            $baseCalculo = $valor;
                                        }
                                        $rubrica['baseCalculo'] = Valor::arredonda($baseCalculo, Valor::TOTAL, -2, 5);
                                    }

                                    // Hora Extra
                                    if ($objRubrica->getIdhoraextra() === FpaHomologrubricaEntity::IDHORAEXTRA_SIM){
                                        $rubrica['horas'] = $referencia;
                                        if (empty($rubrica['horas']) === true) {
                                            $rubrica['horas'] = '0.00';
                                        }
                                    }

                                    // Parametrizacao especifica para o produto
                                    if ($objRubrica->getIdproducao() === FpaHomologrubricaEntity::IDPRODUCAO_SIM){

                                        // Gerar o codigo sequencial do produto
                                        $rubrica['seqCodigo'] = $this->_codigoHnet->verificarCodigo($item->getNreventom(), RegistroCodigoHomolognet::CODIGO_SEQUENCIAL_PRODUTO);
                                        if ($rubrica['seqCodigo'] === false){
                                            $this->_financeiroHnet->incrementaCodSequencialProduto();
                                            $rubrica['seqCodigo'] = $this->_financeiroHnet->getCodSequencialProduto();
                                            $this->_codigoHnet->addListaCodigo($item->getNreventom(), RegistroCodigoHomolognet::CODIGO_SEQUENCIAL_PRODUTO, $rubrica['seqCodigo']);
                                        }
                                    }

                                    switch($this->_vinculo->historico->getIdtppagamento()){
                                        case GpeVinculohEntity::IDTPPAGAMENTO_DIARIO :
                                        case GpeVinculohEntity::IDTPPAGAMENTO_MENSAL_SALARIO_HORA :
                                            $rubrica['horas'] = $referencia;
                                            break;
                                    }

                                    $rubricas[] = $rubrica;

                                } else {
                                    // ----------------|
                                    // RUBRICA EXTERNA |
                                    // ----------------|
    //                                $rubricaExterna = new stdClass();
                                    $rubricaExterna = Array();

                                    // Codigo verba rescisoria - Deve comecar em 100
                                    $rubricaExterna['codigo'] = $objRubrica->getCdhomologrubrica();

                                    // Pesquisa codigo da verba rescisoria na lista e insere caso nao exista
                                    $codVerbaResc = $this->_codigoHnet->verificarCodigo($item->getNreventom(), RegistroCodigoHomolognet::CODIGO_VERBA_RESCISORIA);
                                    if ($codVerbaResc === false){
                                        $this->_codigoHnet->addListaCodigo($item->getNreventom(), RegistroCodigoHomolognet::CODIGO_VERBA_RESCISORIA, $rubricaExterna['codigo']);
                                    }

                                    // Valor da verba rescisoria
                                    $rubricaExterna['valor'] = Valor::arredonda($valor, Valor::TOTAL, -2, 5);

                                    // Indicador de incidencia de tributacao (FGTS, INSS, IRRF)
                                    $rubricaExterna['incidencia'] = $this->_preparaIncidenciaTributacao($item->getNreventom(), $calculo->getDtocorrencia());

                                    // Indicador de integracao de base de calculo
                                    $rubricaExterna['integracao'] = $this->_preparaFinanceiroIntegracaoBaseCalculo($item->getNreventom(), $calculo->getDtocorrencia());

                                    $rubricasExternas[] = $rubricaExterna;

                                }

                                $salario[$calculo->getDtocorrencia()]['rubricas'] = $rubricas;
                                $salario[$calculo->getDtocorrencia()]['rubricasExternas'] = $rubricasExternas;

                            }
                        }

                    }

//                }

            }

            unset($rubricas);
            unset($rubricasExternas);

        }

        // ----- IMPORTATNE ----- Loop no array de codigo para gerar o codigo;
        $listaCodigo = $this->_codigoHnet->getListaCodigo();
//        file_put_contents('/home/leandro/codigos.log', print_r($listaCodigo, true));
        foreach($listaCodigo as $codigo){
            $evento = $this->_evento->retornaEvento($codigo->evento);
            $codigo->descricao = $evento->historico->getNmeventoh();

            $this->_codigoHnet->setCodigo($codigo);
            $this->_codigoHnet->geraRegistroCodigo();

            // Insere Financeiro na lista
            $this->_homologMagnet->insereRegistroLista(
                $this->_nrOrg, $this->_mesCompetencia, FpaHomologmagnetEntity::IDATIVO_SIM, self::CODIGO,
                $this->_nrTpInscricao, $this->_nrInscricao, $this->_codigoHnet->getLinhaRegistro(),
                $this->_nrTpInscricaoTom, $this->_nrInscricaoTom
            );
        }

//        file_put_contents('/home/leandro/salario.log', print_r($salario, true));

        // Qtd DSR no mes afastamento com excecao da ultima semana
        $this->_calendario->carregaDiasUteis($estrutura->historico->getNrcalendario(),$this->_mesCompetencia, $this->_dtRescisao);
        $dsr = $this->_calendario->getVetDSR();
        $financeiro->dsr = count($dsr) - 1;

        $this->_financeiroHnet->setLinhaRegistro();
        $this->_financeiroHnet->geraRegistroFinanceiro($financeiro, $salario);

        // Insere Financeiro na lista
        $this->_homologMagnet->insereRegistroLista(
            $this->_nrOrg, $this->_mesCompetencia, FpaHomologmagnetEntity::IDATIVO_SIM, self::FINANCEIRO,
            $this->_nrTpInscricao, $this->_nrInscricao, $this->_financeiroHnet->getLinhaRegistro(),
            $this->_nrTpInscricaoTom, $this->_nrInscricaoTom
        );

        unset($financeiro);



//        // preparar data auxiliar dos 85 ultimos meses
//        $this->_preparaDataAux(85);
//
//        // Faz loop no array de calculo folha
//        foreach ($this->_listaCalculoFolha as $nrCalculo => $calculo){
//
//            // Verifica se esta no periodo dos 85 meses
//            if (($this->_dtAux->isEarlier($calculo->getDtocorrencia(), TkDateTime::FORMAT_DATE) === true)
//                || ($this->_dtAux->equals($calculo->getDtocorrencia(), TkDateTime::FORMAT_DATE) === true)
//            ){
//
//                // Calcula o numero de meses entre o mes da competencia e a data de ocorrencia do calculo
//                $this->_dtAux2->set($calculo->getDtocorrencia());
//                $mesAnterior = $this->_mesCompetencia->months($this->_dtAux2->toString(TkDateTime::FORMAT_DATE));
//
//                $calculo->anoMes = $calculo->getDtocorrencia();
//
////                tipo Salario
//                switch($this->_vinculo->historico->getIdtppagamento()){
//                    case GpeVinculohEntityBase::IDTPPAGAMENTO_MENSAL_SALARIO_HORA:
//                        $calculo->tipoSalario = RegistroFinanceiroHomolognet::TIPO_SALARIO_HORA;
//                        break;
//                    case GpeVinculohEntityBase::IDTPPAGAMENTO_MENSAL:
//                        $calculo->tipoSalario = RegistroFinanceiroHomolognet::TIPO_SALARIO_MENSAL;
//                        break;
//                    case GpeVinculohEntityBase::IDTPPAGAMENTO_DIARIO:
//                        $calculo->tipoSalario = RegistroFinanceiroHomolognet::TIPO_SALARIO_DIARIO;
//                        break;
//                    default:
//                        $calculo->tipoSalario = '';
//                }
//
//                // Se data da competencia for igual a data de ocorrencia do calculo, busca os itens do calculo
//                $dtCompetencia = new TkDateTime($this->_mesCompetencia);
//                $dtOcorrencia = new TkDateTime($calculo->getDtocorrencia());
//                if ($dtOcorrencia->equals($dtCompetencia)) {
//
//                    // Carrega os itens de calculo para cada calculo de folha
//                    $this->_itemCalculo->retornaItensPorVinculo($this->_nrOrg, $this->_vinculo->getNrvinculom(), $nrCalculo);
//                    $itens = $this->_itemCalculo->getItems();
//
//                    //tratamento para o campo 71 do layout do Homolognet
//                    // Mes -1 é o anterior ao mes da rescisao
//                    if ($mesAnterior === -1){
//
//    //                    Caso raro de acontecer - O pagamento nao foi feito e o funcionario foi demitido antes do 5o dia util
//    //                    Só sera informado para pagamento na rescisão caso o salário do mês anterior ainda não tenha sido
//    //                    pago e a data de quitação da rescisão do contrato de trabalho venha a ocorrer até o quinto dia
//    //                    útil do mês seguinte ao de pagamento do salário não quitado.
//    //
//                        // Verificar se foi gerado o pagamento para o vinculo (Olhar para o CNAB)
//                        $pagamento = $this->_cnabMagnet->retornaRegistroPorVinculoSegmento(
//                            $this->_nrOrg, $this->_dtAux2, $this->_vinculo->getNrvinculom(), Registro3ACNABSantander::SEGMENTO_A
//                        );
//
//                        if (is_object($pagamento) === false){
//
//                            //se pagamento nao foi feito procurar por evento de liquido
//                            $nrEvento = $this->_assocEvento->retornaEvento(FpaTipoassoceveEntity::ASSOC_LIQUIDO, $this->_nrOrg);
//                            $evento = $this->_evento->retornaEvento($nrEvento);
//
//                            $posicao =  $this->_itemCalculo->procuraEvento($evento);
//                            if ($posicao !== -1){
//                                $itemLiquido = $itens[$posicao];
//                                $financeiro->liquido = Valor::arredonda($itemLiquido->getVreventofolha(), Valor::TOTAL, -2, 5);
//                            }
//
//                        }
//                    }
//
//                    //fim do tratamento para o campo 71 do layout do Homolognet
//                    $criouRubrica = false;
//                    $criouRubricaExterna = false;
//                    $criouRbAcumulado = false;
//                    $criouREAcumulado = false;
//
//    //                $nreventos = array();
//
//                    foreach($itens as $item){
//
//                        $nreventos = $item->getNreventom();
//
//                        /*
//                        * Tipo Formação do salário
//                        * Informe de acordo com o seguinte domínio:
//                        * 1. Fixo
//                        * 2. Variável
//                        * 3. Fixo + Variável
//                        */
//    //                    @todo verificar implementacao
//                        if ($nreventos == FpaitecalcfolhaEntity::EVENTO_COMISSAO) {
//                            $calculo->tipoFormacao = self::TIPO_FORMACAO_FIXOVARIAVEL;
//                        } else {
//                            $calculo->tipoFormacao = self::TIPO_FORMACAO_FIXO;
//                        }
//
//    //                    if (in_array(FpaitecalcfolhaEntity::EVENTO_SALARIO_HORA, $nreventos) === false
//    //                        || in_array(FpaitecalcfolhaEntity::EVENTO_SALARIO_MES, $nreventos) === false
//    //                            && in_array(FpaitecalcfolhaEntity::EVENTO_COMISSAO, $nreventos) === true) {
//    //                        $calculo->tipoFormacao = self::TIPO_FORMACAO_VARIAVEL;
//    //                    }
//    //                    if (in_array(FpaitecalcfolhaEntity::EVENTO_SALARIO_HORA, $nreventos) === true
//    //                        || in_array(FpaitecalcfolhaEntity::EVENTO_SALARIO_MES, $nreventos) === true
//    //                            && in_array(FpaitecalcfolhaEntity::EVENTO_COMISSAO, $nreventos) === true) {
//    //                        $calculo->tipoFormacao = self::TIPO_FORMACAO_FIXOVARIAVEL;
//    //                    }
//
//                        $evento = $this->_evento->retornaEvento($item->getNreventom());
//                        $codRubrica = $evento->historico->getNrhomologrubrica();
//                        $tipoEvento = $evento->getIdtipoevento();
//
//                        if ((empty($codRubrica) === false) && ($tipoEvento === FpaEventomEntity::IDTIPOEVENTO_PROVENTO)){
//                            tk_warning('Evento:'. $item->getNreventom() .' Cod Rub: '. $codRubrica .' Tipo '. $tipoEvento);
//                            $objRubrica = $this->_rubrica->retornaRubrica($this->_nrOrg, $this->_nrOrgPadrao, $codRubrica);
//
//                            $orientacao = $objRubrica->getIdorientacao();
//
//                            if ($orientacao === FpaHomologrubricaEntity::IDORIENTACAO_INTERNA){
//                                // ----------------|
//                                // RUBRICA INTERNA |
//                                // ----------------|
//                                $rubrica = new stdClass();
//                                $rubrica->codigo = $objRubrica->getCdhomologrubrica();
//
//                                if ($objRubrica->getIdvalor() === FpaHomologrubricaEntity::IDVALOR_SIM){
//                                    $rubrica->valor = Valor::arredonda($item->getVreventofolha(), Valor::TOTAL, -2, 5);
//                                }
//
//                                // Quantidade de Produtos
//                                if ($objRubrica->getIdquantidade() === FpaHomologrubricaEntity::IDQUANTIDADE_SIM){
//                                    $rubrica->quantidade = $item->getVrreffolha();
//                                }
//
//                                if ($objRubrica->getIdpercentual() === FpaHomologrubricaEntity::IDPERCENTUAL_SIM){
//                                    $rubrica->percentual = $item->getVrreffolha();
//                                }
//
//                                // Base de calculo - Valor unitario para produto, valor total para os demais
//                                if ($objRubrica->getIdbasecalculo() === FpaHomologrubricaEntity::IDBASECALCULO_SIM){
//                                    if (empty($rubrica->quantidade) === false){
//                                        // Caso PRODUCAO
//                                        $baseCalculo = $item->getVreventofolha() / $rubrica->quantidade;
//                                    } else {
//                                        // Caso INSALUBRIDADE, PERICILOSIDADE, TEMPO SERVICO, TRANSFERENCIA
//                                        $baseCalculo = $item->getVreventofolha();
//                                    }
//                                    $rubrica->baseCalculo = Valor::arredonda($baseCalculo, Valor::TOTAL, -2, 5);
//                                }
//
//                                // Parametrizacao especifica para o produto
//                                if ($objRubrica->getIdproducao() === FpaHomologrubricaEntity::IDPRODUCAO_SIM){
//
//                                    // Gerar o codigo sequencial do produto
//                                    $rubrica->seqCodigo = $this->_codigoHnet->verificarCodigo($item->getNreventom(), RegistroCodigoHomolognet::CODIGO_SEQUENCIAL_PRODUTO);
//                                    if ($rubrica->seqCodigo === false){
//                                        $rubrica->seqCodigo = $this->_financeiroHnet->getCodSequencialProduto();
//                                        $this->_codigoHnet->addListaCodigo($item->getNreventom(), RegistroCodigoHomolognet::CODIGO_SEQUENCIAL_PRODUTO);
//                                        $this->_financeiroHnet->incrementaCodSequencialProduto();
//                                    }
//                                }
//
//                                switch($this->_vinculo->historico->getIdtppagamento()){
//                                    case GpeVinculohEntity::IDTPPAGAMENTO_DIARIO :
//                                    case GpeVinculohEntity::IDTPPAGAMENTO_MENSAL_SALARIO_HORA :
//                                        $rubrica->horas = $item->getVrreffolha();
//                                        break;
//                                }
//
////                                $this->_financeiroHnet->setRubrica($rubrica);
//                                $this->_financeiroHnet->setLinhaRegistro();
//                                $this->_financeiroHnet->geraRegistroRubrica($rubrica);
//                                $this->_financeiroHnet->concatenaRubrica();
//                                $criouRubrica = false;
//                                $criouRbAcumulado = true;
//                            }
////                            } else {
////                                // ----------------|
////                                // RUBRICA EXTERNA |
////                                // ----------------|
////                                $rubricaExterna = new stdClass();
////
////                                // Codigo verba rescisoria - Deve comecar em 100
////                                $rubricaExterna->codigo = $objRubrica->getCdhomologrubrica();
////
////                                // Pesquisa codigo da verba rescisoria na lista e insere caso nao exista
////                                $codVerbaResc = $this->_codigoHnet->verificarCodigo($item->getNreventom(), RegistroCodigoHomolognet::CODIGO_VERBA_RESCISORIA);
////                                if ($codVerbaResc === false){
////                                    $this->_codigoHnet->addListaCodigo($item->getNreventom(), RegistroCodigoHomolognet::CODIGO_VERBA_RESCISORIA, $rubricaExterna->codigo);
////                                }
////
////                                // Valor da verba rescisoria
////                                $rubricaExterna->valor = Valor::arredonda($item->getVreventofolha(), Valor::TOTAL, -2, 5);
////
////                                // Indicador de incidencia de tributacao (FGTS, INSS, IRRF)
////                                $rubricaExterna->incidencia = $this->_preparaIncidenciaTributacao($item->getNreventom(), $calculo->getDtocorrencia());
////
////                                // Indicador de integracao de base de calculo
////                                $rubricaExterna->integracao = $this->_preparaFinanceiroIntegracaoBaseCalculo($item->getNreventom(), $calculo->getDtocorrencia());
////
////                                $criouRubricaExterna = true;
////                            }
//
//
////                            if ($criouRubricaExterna === true){
////                                $this->_financeiroHnet->setLinhaRegistro();
////                                $this->_financeiroHnet->geraRegistroRubricaExterna($rubricaExterna);
////                                $this->_financeiroHnet->concatenaRubricaExterna();
////                                $criouRubricaExterna = false;
////                                $criouREAcumulado = true;
////                            }
////
//                            unset($rubrica);
//                            unset($rubricaExterna);
//                        }
//
//                    }
//
//                }
//
//            }
//
////            // So gerar salario se gerar rubricas
//            if (($criouRbAcumulado === true) || ($criouREAcumulado === true)){
//                $this->_financeiroHnet->setLinhaRegistro();
//                $this->_financeiroHnet->geraRegistroSalario($calculo);
//                $this->_financeiroHnet->concatenaSalario();
//
//                // Limpa os valores das Rubricas
////                $this->_financeiroHnet->setRubrica();
////                $this->_financeiroHnet->setRubricaExterna();
//            }
//
//            unset($calculo);
//
//        }
////        file_put_contents('neeventos.log',print_r($nreventos, true));
//        // ----- IMPORTATNE ----- Loop no array de codigo para gerar o codigo;
//
//        /*   $listaCodigo = $this->_codigoHnet->getListaCodigo();
//            foreach($listaCodigo as $codigo){
//                $evento = $this->_evento->retornaEvento($codigo->evento);
//                $codigo->descricao = $evento->historico->getNmeventoh();
//
//                $this->_codigoHnet->setCodigo($codigo);
//                $this->_codigoHnet->geraRegistroCodigo();
//            }
//        */
////        file_put_contents('historico.log', print_r($estrutura, true));
//        // Qtd DSR no mes afastamento com excecao da ultima semana
//        $this->_calendario->carregaDiasUteis($estrutura->historico->getNrcalendario(),$this->_mesCompetencia, $this->_dtRescisao);
//        $dsr = $this->_calendario->getVetDSR();
//        //$dsr = array_count_values($this->_calendario->getVetDiasUteis());
//        //$financeiro->dsr = $dsr[CalendarioLogic::DIA_NAO_UTIL] - 1;
//        $financeiro->dsr = count($dsr) - 1;
//        $this->_financeiroHnet->setLinhaRegistro();
//        $this->_financeiroHnet->geraRegistroFinanceiro($financeiro);
//
//        unset($financeiro);

    }


    private function _preparaDescontos(){

        // Gerar os descontos externos no financeiro
        $outrosDescontos = $this->_preparaOutrosDescontos();

        /* GRUPO DE INCIDENCIAS */
        $desconto = new stdClass();

        // Adiantamento Salarial - Evento: 470 / Tipo Incidencia: 50
        $desconto->adiantamentoSalarial = $this->_itemGrupo->calculaValorItemGrupoIncidencia(
            $this->_dtRescisao, $this->_itemCalculo, $this->_evento, RegistroHomolognet::ADIANTAMENTO_SALARIAL
        );

        // Adiantamento 13 Salario - Evento: 120 / Tipo Incidencia: 48
        $desconto->adiantamento13Salarial = $this->_itemGrupo->calculaValorItemGrupoIncidencia(
            $this->_dtRescisao, $this->_itemCalculo, $this->_evento, RegistroHomolognet::ADIANTAMENTO_13SALARIO
        );

        //faltas - Evento: 1040 / Tipo Incidencia: 30 @todo verificar implementação
        $desconto->faltas = $this->_Nrfaltas;

//        $desconto->faltas = $this->_itemGrupo->calculaValorItemGrupoIncidencia(
//            $this->_dtRescisao, $this->_itemCalculo, $this->_evento, RegistroHomolognet::FALTAS_INJUSTIFICADAS
//        );

        // Valor do Vale Transporte - Evento: 480 e 1080 / Tipo Incidencia: 69
        $desconto->valeTransporte = $this->_itemGrupo->calculaValorItemGrupoIncidencia(
            $this->_dtRescisao, $this->_itemCalculo, $this->_evento, RegistroHomolognet::VALE_TRANSPORTE
        );

        // Valor do Vale Alimentacao - Evento: 100855 / Tipo Incidencia: 59
        $desconto->valeAlimentacao = $this->_itemGrupo->calculaValorItemGrupoIncidencia(
            $this->_dtRescisao, $this->_itemCalculo, $this->_evento, RegistroHomolognet::VALE_ALIMENTACAO
        );

//        // Valor Reembolso Vale de Transporte - Evento: 1080 - NÂO OBRIGATÒRIO
//        $desconto->reembolsoValeTransporte = $this->_itemGrupo->calculaValorItemGrupoIncidencia(
//            $this->_dtRescisao, $this->_itemCalculo, $this->_evento, RegistroHomolognet::REEMBOLSO_VALE_TRANSPORTE
//        );
//
//        // Valor Reembolso Vale Alimentacao - NÂO OBRIGATÒRIO
//        $desconto->reembolsoValeAlimentacao = $this->_itemGrupo->calculaValorItemGrupoIncidencia(
//            $this->_dtRescisao, $this->_itemCalculo, $this->_evento, RegistroHomolognet::REEMBOLSO_VALE_ALIMENTACAO
//        );

        // Valor Credito Consignado - Evento: 100015 / Tipo Incidencia: 62
        $desconto->creditoConsignado = $this->_itemGrupo->calculaValorItemGrupoIncidencia(
            $this->_dtRescisao, $this->_itemCalculo, $this->_evento, RegistroHomolognet::CREDITO_CONSIGNADO
        );

        // Valor Indenizacao Art 480 - Evento: 1700 / Tipo Incidencia: 63
        $desconto->indenizacao = $this->_itemGrupo->calculaValorItemGrupoIncidencia(
            $this->_dtRescisao, $this->_itemCalculo, $this->_evento, RegistroHomolognet::INDENIZACAO_ART480
        );

        // Valor Contribuicao Previdencia Privada - Evento:  / Tipo Incidencia: 64 @todo criada apenas a incidência, os eventos serão criados incididos conforme necessidade de cada organização
        $desconto->previdenciaPrivada = $this->_itemGrupo->calculaValorItemGrupoIncidencia(
            $this->_dtRescisao, $this->_itemCalculo, $this->_evento, RegistroHomolognet::PREVIDENCIA_PRIVADA
        );

        // Valor Contribuicao Fapi - Evento:  / Tipo Incidencia: 65 - ESTÁ EM DESUSO PELO MP @todo criada apenas a incidência, os eventos serão criados incididos conforme necessidade de cada organização
        $desconto->fapi = $this->_itemGrupo->calculaValorItemGrupoIncidencia(
            $this->_dtRescisao, $this->_itemCalculo, $this->_evento, RegistroHomolognet::CONTRIBUICAO_FAPI
        );

        // Valor Contribuicao Sindical Laboral - Evento: 1060 / Tipo Incidencia: 32
        $desconto->contribuicaoSindicalLaboral = $this->_itemGrupo->calculaValorItemGrupoIncidencia(
            $this->_dtRescisao, $this->_itemCalculo, $this->_evento, RegistroHomolognet::CONTRIBUICAO_SINDICAL_LABORAL
        );

        // Valor Outras Deducoes Base Calculo IRRF - Evento:  / Tipo Incidencia: 70 @todo criada apenas a incidência, os eventos serão criados incididos conforme necessidade de cada organização
        $desconto->outrasDeducoesIRRF = $this->_itemGrupo->calculaValorItemGrupoIncidencia(
            $this->_dtRescisao, $this->_itemCalculo, $this->_evento, RegistroHomolognet::OUTRAS_DEDUCOES_BASE_CALCULO_IRRF
        );

//        // Valor Compensacao Dias Salario Ferias Mes Afastamento - NÂO OBRIGATÒRIO
//        $desconto->compensacaoDias = $this->_itemGrupo->calculaValorItemGrupoIncidencia(
//            $this->_dtRescisao, $this->_itemCalculo, $this->_evento, RegistroHomolognet::COMPENSACAO_DIAS_SALARIO_FERIAS_MES_AFASTAMENTO
//        );

        // Valor Complementacao IRRF Rendimento Mes Quitacao - Evento:  / Tipo Incidencia: 71 @todo criada apenas a incidência, os eventos serão criados incididos conforme necessidade de cada organização
        $desconto->complementacaoIRRF = $this->_itemGrupo->calculaValorItemGrupoIncidencia(
            $this->_dtRescisao, $this->_itemCalculo, $this->_evento, RegistroHomolognet::COMPLEMENTACAO_IRRF_MES_QUITACAO
        );

        /* FIM GRUPO INCIDENCIAS */

        $this->_descontoHnet->setOutrosDescontos($this->_descontoHnet->getLinhaRegistro());
        $this->_descontoHnet->setDesconto($desconto);
        $this->_descontoHnet->geraRegistroDesconto($outrosDescontos);

        // Insere Desconto na lista
        $this->_homologMagnet->insereRegistroLista(
            $this->_nrOrg, $this->_mesCompetencia, FpaHomologmagnetEntity::IDATIVO_SIM, self::DESCONTO,
            $this->_nrTpInscricao, $this->_nrInscricao, $this->_descontoHnet->getLinhaRegistro(),
            $this->_nrTpInscricaoTom, $this->_nrInscricaoTom
        );
    }

    /*
        // @todo - Passar pro percorre e atribuir para o Homolognet
        private function _preparaListaEventosGrupoIncidencia(){
            $this->_listaEventosGrupoIncidencia = array();
            $listaTipoIncidencia = $this->_itemGrupo->getListaIncidencias();

            foreach ($listaTipoIncidencia as $tipoIncidencia){
                // Retornar os eventos da incidencia
                $nrEventos = FpaincideventoEntity::getEventos($this->_dtRescisao, $tipoIncidencia);

                foreach($nrEventos as $nrEvento){
                    $evento = $this->_evento->retornaEvento($nrEvento);
                    $this->_listaEventosGrupoIncidencia[$nrEvento] = $evento;
                }
            }
        }
    */

    private function _preparaOutrosDescontos(){

        // Calculo de Folha no mes da rescisao
        $calculo = end($this->_listaCalculoFolha);

        if($calculo){

            // Carrega itens de calculo no mes da rescisao
            $this->_itemCalculo->retornaItensPorVinculo($this->_nrOrg, $this->_vinculo->getNrvinculom(), $calculo->getNrcalculofolha());

            //  $this->_preparaListaEventosGrupoIncidencia();
            $itens = $this->_itemCalculo->getItems();
//            file_put_contents('/home/leandro/outros.log', print_r($this->_listaEventosGrupoIncidencia, true));
            foreach ($itens as $item){
                $evento = $this->_evento->retornaEvento($item->getNreventom());
                if ($evento->getIdtipoevento() === FpaEventomEntity::IDTIPOEVENTO_DESCONTO){
                    if (array_key_exists($item->getNreventom(), $this->_listaEventosGrupoIncidencia) === false){

                        $outrosDescontos = new stdClass();

                        $codDesconto = $this->_codigoHnet->verificarCodigo($item->getNreventom(), RegistroCodigoHomolognet::CODIGO_DESCONTO);
                        if ($codDesconto === false){
                            $codDesconto = $this->_descontoHnet->getCodDesconto();
                            $this->_codigoHnet->addListaCodigo($item->getNreventom(), RegistroCodigoHomolognet::CODIGO_DESCONTO, $codDesconto);
                            $this->_descontoHnet->incrementaCodDesconto();
                        }
                        $outrosDescontos->codigo = $codDesconto;

                        // Verifica se codigo incide para IRRF, INSS ou FGTS
                        $outrosDescontos->tributacao = $this->_preparaIncidenciaTributacao($item->getNreventom(), $this->_dtRescisao);
                        $outrosDescontos->valor = $item->getVreventofolha();

                        return $outrosDescontos;

//                        $this->_descontoHnet->setLinhaRegistro();
//                        $this->_descontoHnet->geraOutrosDescontos($outrosDescontos);
//                        $this->_descontoHnet->concatenaOutrosDescontos();
                        // $this->_descontoHnet->setOutrosDescontos($this->_descontoHnet->getLinhaRegistro());

                        // Pesquisa codigo de desconto na lista e insere caso nao exista
                        /*
                            $codigo->tipoCodigo = RegistroCodigoHomolognet::CODIGO_DESCONTO;
                            $codigo->codigo = $evento->getNreventom();
                            $codigo->descricao = $evento->historico->getNmeventoh();
                            $this->_codigoHnet->setCodigo($codigo);
                            $this->_codigoHnet->geraRegistroCodigo();
                        */

                    }
                }
            }
        }else{
            throw new Exception('Vínculo '.$this->_vinculo->getNrvinculom().' não possui cálculo.');
        }

    }


    private function _preparaIncidenciaTributacao($nrEvento, $dtOcorrencia){
        $incidencia = '';
        if (FpaincideventoEntity::incide(FpaTipoincideEntity::INC_FGTS_CALC, $nrEvento, $dtOcorrencia) === false){
            $incidencia .= '0';
        } else {
            $incidencia .= '1';
        }

        if (FpaincideventoEntity::incide(FpaTipoincideEntity::INC_INSS_CALC, $nrEvento, $dtOcorrencia) === false){
            $incidencia .= '0';
        } else {
            $incidencia .= '1';
        }

        if (FpaincideventoEntity::incide(FpaTipoincideEntity::INC_IRRF_CALC, $nrEvento, $dtOcorrencia) === false){
            $incidencia .= '0';
        } else {
            $incidencia .= '1';
        }

        return $incidencia;

    }


    private function _preparaFinanceiroIntegracaoBaseCalculo($nrEvento, $dtOcorrencia){
        $integracao = '';
        if (FpaincideventoEntity::incide(FpaTipoincideEntity::INC_FERIAS, $nrEvento, $dtOcorrencia) === false){
            $integracao .= '0';
        } else {
            $integracao .= '1';
        }

        if (FpaincideventoEntity::incide(FpaTipoincideEntity::INC_13SAL, $nrEvento, $dtOcorrencia) === false){
            $integracao .= '0';
        } else {
            $integracao .= '1';
        }

        if (FpaincideventoEntity::incide(FpaTipoincideEntity::INC_AVISO_PREVIO, $nrEvento, $dtOcorrencia) === false){
            $integracao .= '0';
        } else {
            $integracao .= '1';
        }

        return $integracao;
    }



    private function _preparaVerbasRescisorias(){
        // Desconto so e gerado no mes da rescisao

        $this->_preparaDataAux(85);

        // Loop no array de calculo folha
        foreach ($this->_listaCalculoFolha as $nrCalculo => $calculo){

            $dtOcorrencia = $calculo->getDtocorrencia();

            // Verifica se esta no periodo dos 85 meses
            if (($this->_dtAux->isEarlier($dtOcorrencia, TkDateTime::FORMAT_DATE) === true)
                || ($this->_dtAux->equals($dtOcorrencia, TkDateTime::FORMAT_DATE) === true)
            ){

                $this->_itemCalculo->retornaItensPorVinculo($this->_nrOrg, $this->_vinculo->getNrvinculom(), $nrCalculo);
                $itens = $this->_itemCalculo->getItems();

                // Limpar rubrica
                // Limpar rubricaExterna


                /*  if ($this->_itemCalculo->countItems() > 0){
                    $this->_financeiroHnet->setDtSalario();
                    $this->_financeiroHnet->setTpFormacao();
                    $this->_financeiroHnet->setTpSalario();
                }*/

                // Loop nos itens de calculo
                foreach($itens as $item){

                    //procura evento
                    //$posicao = $this->_itemCalculo->procuraEvento($item->getNreventom());
                    $evento = $this->_evento->retornaEvento($item->getNreventom());
                    //file_put_contents('historico.log', print_r($evento->historico, true));
                    $codRubrica = $evento->historico->getNrhomologrubrica();
                    $tipoEvento = $evento->getIdtipoevento();

                    // pegar o evento e verificar se o mesmo tem rubrica (condicao para o evento entrar no termo de rescisao)
                    if (empty($codRubrica) === false){

                        $objRubrica = $this->_rubrica->retornaRubrica($this->_nrOrg, $this->_nrOrgPadrao, $codRubrica);

                        $orientacao = $objRubrica->getIdorientacao();

                        // Usado para a contagem de produto e horas extras. Para outras rubricas seu valor eh 0;
                        $indice = 0;

                        // verificar o tipo do evento (provento / desconto) - FINANCEIROS
                        if ($evento->getIdtipoevento() === FpaEventomEntity::IDTIPOEVENTO_PROVENTO) {

                            // DtAnoMes
                            // TpFormacao (1 - Fixo, 2 - Variável, 3 - Fixo + Variável)
                            // TpSalario (1 - Hora, 2 - Mensal, 3 - Diário)

                            // para provento, verificar se rubrica interna ou externa
                            if ($orientacao === FpaHomologrubricaEntity::IDORIENTACAO_INTERNA){


                                // Codigo da Rubrica
                                // Valor da Rubrica
                                // Valor Base de Calculo
                                // Qtd Produto
                                // Percentual

                                // Se rubrica de producao
                                // Gerar numero sequencial do produto

                                // Se rubrica de horas extras
                                // Gerar numero de horas extras

                                // Add Rubrica
                                // listaRI[codRubrica][$indice] =
                            } else {
                                /*
                                    <CDRubricaExterna>150</CDRubricaExterna>
									<VLVerbaRescisoria>25.50</VLVerbaRescisoria>
									<CDIncidenteTributacao>001 </CDIncidenteTributacao>
									<CDIndicadorIntegracaoBaseCalculo>001 </CDIndicadorIntegracaoBaseCalculo>
                                */
                            }
                            // Rubrica interna prepara com tag de <Rubrica>
                            // Rubrica externa prepara com tag de <RubricaExterna>

                            // DESCONTOS
                        } elseif ($evento->getIdtipoevento() === FpaEventomEntity::IDTIPOEVENTO_DESCONTO) {

                            // para desconto verificar se eh mes da rescisao
                            // verificar se rubrica interna ou externa
                            // popular desconto interno ou gerar outros descontos (gerar codigos)
                        }
                    }

                }

                // Gerar o cabecalho das rubricas


            }

        }



        // gerar descontos internos / gerar descontos
        // gerar dados do financeiro


    }


    /*  private function _preparaCodigos(){

    }*/

    private function _pensaoJuridica(){
        $valor = $this->_calculaValorItemGrupo(RegistroHomolognet::HOMOLOGNET_PENSAO_JURIDICA);
        $this->_consolidaDadosPensaoJuridica(RegistroHomolognet::HOMOLOGNET_PENSAO_JURIDICA, $valor);
    }

    private function _calculaValorItemGrupo($referencia){
        $valor = $this->_itemGrupo->calculaValorItemGrupoIncidencia($this->_mesCompetencia, $this->_itemCalculo,
            $this->_evento, $referencia);
        return $valor;
    }

    private function _consolidaDadosPensaoJuridica($referencia, $valor) {
        $this->_dadoPensaoJuridica[$referencia] += $valor;
    }

    /*
     * Implementado funcao retroceder
     *
     * @author leonardocarvalho - 08/04/2013
     *
     */
    public function retroceder(){
        $this->_homologMagnet->retroceder($this->_nrOrg, $this->_mesCompetencia);
    }

    private function _preparaDataAux($meses){
        $this->_dtAux->set($this->_dtRescisao);
        $this->_dtAux->subMonth($meses);
    }

    public function geraTagEmpregador($xml){
        $this->_empregadorHnet->geraTag($xml);
    }

    public function geraTagEmpregado($xml){
        $this->_empregadoHnet->geraTag($xml);
    }

    public function geraTagContrato($xml){
        $this->_contratoHnet->geraTag($xml);
    }

    public function geraTagFerias($xml){
        $this->_feriasHnet->geraTag($xml);
    }

    public function geraTagDecimoTerceiroSalario($xml){
        $this->_decimoTerceiroHnet->geraTag($xml);
    }

    public function geraTagMovimentacao($xml){
        $this->_movimentacaoHnet->geraTag($xml);
    }

    public function geraTagFinanceiro($xml){
        $this->_financeiroHnet->geraTag($xml);
    }

    public function geraTagDesconto($xml){
        $this->_descontoHnet->geraTag($xml);
    }

    public function geraTagCodigo($xml){
        $this->_descontoHnet->geraTag($xml);
    }

    /*
    private function _carregaItensCalculo($nrVinculo){

        foreach ($this->_listaCalculoFolha as $nrCalculo){

            $contador = $this->_itemCalculo->retornaItensPorVinculo($this->_nrOrg, $nrVinculo, $nrCalculo);
        }

    }

    */
//     private function _calculaFaltasInjustificadas(){
//        $valor = $this->_calculaValorItemGrupo(RegistroHomolognet::FALTAS_INJUSTIFICADAS);
//         return $valor;
//     }


}
